
asset_dir = 'liktarna_assets/'
fnt = asset_dir..'AlegreyaSans.ttf'

scr_size = vec2(960, 640)
scr_rect = rect(0, 0, scr_size.x, scr_size.y)
text_color = rgba(1, 1, 1)

function manhattan_distance(a, b)
	return math.abs(a.x - b.x) + math.abs(a.y - b.y)
end

local math_floor = math.floor
function feql(a, b)
	if a == nil or b == nil then
		print(debug.traceback())
	end
	local d = a - b
	return d*d < 0.0000001
end

function eql_pos(a, b)
	if b == nil then
		print(debug.traceback())
	end
	return feql(a.x, b.x) and feql(a.y, b.y)
end

function pos_in_table(pos, t)
	if t == nil then
		print(debug.traceback())
	end
	for _,p in ipairs(t) do
		if eql_pos(p, pos) then
			return true
		end
	end
	return false
end

local game = require('game')
local room = require('room')
local text = require('text')
local levels = require('levels')
local intro = require('intro')
local epilogue = require('epilogue')

function game_init()
	local scale = 1
	local real_size = scr_size * scale
	video.init_ex(real_size.x, real_size.y, scr_size.x, scr_size.y, 'Melas', false)
	video.clear_color(rgba(0.04, 0.04, 0.04, 1))
	sound.init()

--	vfont.select(asset_dir..'Magra-Regular.ttf', 42)
	vfont.select(fnt, 42)
--	particles.init(asset_dir, 1)
	mfx.init(asset_dir..'effects.mml')
	sprsheet.init(asset_dir..'sprsheet.mml')
	mus = sound.load_stream(asset_dir..'Hyperfun.ogg')

	states.prerender_callback(function()
--		sprsheet.draw('background', 0, vec2(0, 0))
		sound.update()
		mfx.update()
--		particles.update()
--		particles.draw()
	end)

	states.transition_len = 0.6
	states.register('game', game)
	states.register('room', room)
	states.register('text', text)
	states.register('intro', intro)
	states.register('epilogue', epilogue)
	
	states.push('intro')
end

function game_close()
	sound.free(mus)
	vfont.close()
	sprsheet.close()
	mfx.close()
--	particles.close()
	sound.close()
	video.close()
end
